



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ZOJ2588 Burning Bridges（割边模板）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ZOJ2588 Burning Bridges（割边模板）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 04:19:16 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题目要输出一个无向图的所有割边。用Tarjan算法：</p>
<p>一遍DFS，构造出一颗深度优先生成树，在原<strong>无向图</strong>中边分成了两种：<strong>树边</strong>（生成树上的边）和<strong>反祖边</strong>（非生成树上的边）。</p>
<p>顺便求出每个结点的DFS序<strong><em>dfn[u]&nbsp;</em></strong>和 每个结点能沿着它和它的儿子的返祖边达到的结点最小的DFS序<strong><em>low[u]</em></strong>。</p>
<p>一条边(u,v)是割边当且仅当&mdash;&mdash;</p>
<ul><li>low[v]&gt;dfn[u]</li></ul>
<p>注意具体实现时，无向图的边在邻接表中有正反两条边，那么如果一条边是树边了，另一条边不应该是反祖边，要忽略。</p>
<div>
<pre class="prettyprint linenums"> #include&lt;cstdio&gt;<br />
 #include&lt;cstring&gt;<br />
 #include&lt;algorithm&gt;<br />
 using namespace std;<br />
 #define MAXM 222222<br />
 #define MAXN 11111<br />
 struct Edge{<br />
     int v,next;<br />
     bool tag;<br />
 }edge[MAXM];<br />
 int NE,head[MAXN];<br />
 void addEdge(int u,int v){<br />
     edge[NE].v=v; edge[NE].next=head[u]; edge[NE].tag=;<br />
     head[u]=NE++;<br />
 }<br />
 int dn,dfn[MAXN],low[MAXN],res[MAXM],resn;<br />
 void dfs(int u){<br />
     dfn[u]=low[u]=++dn;<br />
     for(int i=head[u]; i!=-; i=edge[i].next){<br />
         if(edge[i].tag) continue;<br />
         int v=edge[i].v;<br />
         if(dfn[v]){<br />
             low[u]=min(low[u],dfn[v]);<br />
             continue;<br />
         }<br />
         edge[i].tag=edge[i^].tag=;<br />
         dfs(v);<br />
         low[u]=min(low[u],low[v]);<br />
         if(low[v]&gt;dfn[u]) res[resn++]=(i&gt;&gt;)+;<br />
     }<br />
 }<br />
 int main(){<br />
     int t,n,m,a,b;<br />
     scanf("%d",&amp;t);<br />
     while(t--){<br />
         scanf("%d%d",&amp;n,&amp;m);<br />
         NE=;<br />
         memset(head,-,sizeof(head));<br />
         while(m--){<br />
             scanf("%d%d",&amp;a,&amp;b);<br />
             addEdge(a,b); addEdge(b,a);<br />
         }<br />
         resn=dn=;<br />
         memset(dfn,,sizeof(dfn));<br />
         dfs();<br />
         printf("%d\n",resn);<br />
         sort(res,res+resn);<br />
         for(int i=; i&lt;resn; ++i){<br />
             if(i) putchar(' ');<br />
             printf("%d",res[i]);<br />
         }<br />
         if(resn) putchar('\n');<br />
         if(t) putchar('\n');<br />
     }<br />
     return ;<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49g0r40q.html">关闭MyEclipse Derby服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1n03z9.html">【python】lxml处理命名空间</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxpllz9.html">BPM到底能做什么？K2为你解读</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k32z5q.html">android 定位的四种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k10j4r9.html">Web Project配置Hirbernate</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zm6n29.html">2013 Asia Regional Changchun I 题，HDU&lpar;4821&rpar;，Hash</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdd6g48.html">fedora 关闭、禁止selinux</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yyepjq.html">牛场围栏（vijos 1054）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxneejd8.html">leetcode 题解：Remove Duplicates from Sorted Array II（已排序数组去三次及以上重复元素）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xdyjv8.html">Linux&lpar;Centos&rpar;全自动异地备份数据（WEB&plus;Mysql）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydl0ygq.html">web2py相关-------------------------------（一）初遇</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz1ome8.html">css兼容性问题的整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgmlwr8.html">&amp;lt&semi;select&amp;gt&semi;设置multiple&equals;&amp;quot&semi;multiple&amp;quot&semi;属性后 下拉框全部展开了 不再是折叠的怎么回事</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25kdkxq.html">linux下ftp服务器搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7owd5x8.html">js 窗口滚动到一定高度时加载数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll3oy1q.html">vs2015 C&num;打包程序为exe</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjv7009.html">异步任务利器Celery&lpar;二&rpar;在django项目中使用Celery</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpm4v09.html">C语言复习---选择法排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/8koo265q.html">border-radius背景色超出圆角问题解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve3r3j9.html">Python爬虫入门 之 如何在豆瓣中获取自己喜欢的TOP N电影信息</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/oqvx2yo8.html">java类的加载过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jk1yg8.html">xxxx is not translated in zh-rCN&comma; zh-rTW</a>
			</li>
						<li><a href="https://www.batexi.com/a/39ro4z49.html">Unbuntu 下编译安装 PHP 必要库的安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyp2vdq.html">&lbrack;BZOJ1941&rsqb;&lbrack;Sdoi2010&rsqb;Hide and Seek</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1e5e59.html">Delphi10 安装Graphics32</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mgwv08.html">java回顾巩固</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qypgx2q.html">iOS 和Android中的基本日期处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlypmx9.html">利用runTime，实现以模型为主的字典转模型（注意与KVC的区别）</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o7251q.html">基因变异（codevs 3194）</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx1x1v9.html">Lucene查询索引（分页）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
